Index: src/UIElements/Views/Qt4/MoleculeList/QtMoleculeList.cpp
===================================================================
--- src/UIElements/Views/Qt4/MoleculeList/QtMoleculeList.cpp	(revision cc297688a2f09a635ccb45323617573684f51f9d)
+++ src/UIElements/Views/Qt4/MoleculeList/QtMoleculeList.cpp	(revision 015f8c18d74c335a5af0741c3ff7f82dfcbfa0d1)
@@ -178,4 +178,13 @@
 }
 
+const QModelIndex QtMoleculeList::MoleculeIdToIndex(const moleculeId_t _id) const
+{
+  boost::recursive_mutex::scoped_lock lock(refill_mutex);
+  QtMoleculeItem * const item = MoleculeIdToItem(_id);
+  ASSERT(item != NULL,
+      "QtMoleculeList::MoleculeIdToIndex() - could not find item to "
+      +toString(_id));
+  return indexFromItem(item);
+}
 
 const moleculeId_t QtMoleculeList::IndexToMoleculeId(const QModelIndex &_index) const
Index: src/UIElements/Views/Qt4/MoleculeList/QtMoleculeList.hpp
===================================================================
--- src/UIElements/Views/Qt4/MoleculeList/QtMoleculeList.hpp	(revision cc297688a2f09a635ccb45323617573684f51f9d)
+++ src/UIElements/Views/Qt4/MoleculeList/QtMoleculeList.hpp	(revision 015f8c18d74c335a5af0741c3ff7f82dfcbfa0d1)
@@ -86,6 +86,7 @@
   bool isMoleculeItemPresent(const moleculeId_t _molid) const;
   QtMoleculeItem * MoleculeIdToItem(const moleculeId_t _molid) const;
+  const moleculeId_t ItemToMoleculeId(const QtMoleculeItem * const _item) const;
+  const QModelIndex MoleculeIdToIndex(const moleculeId_t _id) const;
   const moleculeId_t IndexToMoleculeId(const QModelIndex &_index) const;
-  const moleculeId_t ItemToMoleculeId(const QtMoleculeItem * const _item) const;
   QtMoleculeItem * getSpecificMoleculeItem(
       const QtMoleculeItem * const _item,
Index: src/UIElements/Views/Qt4/MoleculeList/QtMoleculeListView.cpp
===================================================================
--- src/UIElements/Views/Qt4/MoleculeList/QtMoleculeListView.cpp	(revision cc297688a2f09a635ccb45323617573684f51f9d)
+++ src/UIElements/Views/Qt4/MoleculeList/QtMoleculeListView.cpp	(revision 015f8c18d74c335a5af0741c3ff7f82dfcbfa0d1)
@@ -37,4 +37,5 @@
 #include "UIElements/Views/Qt4/MoleculeList/QtMoleculeList.hpp"
 #include "UIElements/Views/Qt4/MoleculeList/QtMoleculeItem.hpp"
+#include "UIElements/Views/Qt4/QtSelectionChangedAgent.hpp"
 
 #include "CodePatterns/MemDebug.hpp"
@@ -53,12 +54,8 @@
 {
   setSelectionMode(QAbstractItemView::MultiSelection);
-
-  World::getInstance().signOn(this, World::SelectionChanged);
 }
 
 QtMoleculeListView::~QtMoleculeListView()
-{
-  World::getInstance().signOff(this, World::SelectionChanged);
-}
+{}
 
 void QtMoleculeListView::setModel(QtMoleculeList *_moleculelist)
@@ -69,4 +66,13 @@
       selectionModel(), SIGNAL(selectionChanged(const QItemSelection &, const QItemSelection &)),
       this, SLOT(rowsSelected(const QItemSelection &, const QItemSelection &)), Qt::DirectConnection);
+}
+
+
+void QtMoleculeListView::setSelectionChangedAgent(QtSelectionChangedAgent *agent)
+{
+  connect(agent, SIGNAL(moleculeSelected(const moleculeId_t)),
+      this, SLOT(MoleculeSelected(const moleculeId_t)));
+  connect(agent, SIGNAL(moleculeUnselected(const moleculeId_t)),
+      this, SLOT(MoleculeUnselected(const moleculeId_t)));
 }
 
@@ -148,4 +154,45 @@
   selecting = false;
 }
+
+void QtMoleculeListView::MoleculeSelected(const moleculeId_t _id)
+{
+  if (selecting)
+    return;
+
+  selecting = true;
+
+  const QtMoleculeList *moleculelist = dynamic_cast<const QtMoleculeList *>(model());
+  QModelIndex index = moleculelist->MoleculeIdToIndex(_id);
+  ASSERT( !selectionModel()->isSelected(index),
+      "QtMoleculeListView::MoleculeSelected() - row to molecule "
+      +toString(_id)+" is already selected.");
+
+  // select the full row
+  expand(index);
+  selectionModel()->select(index, QItemSelectionModel::Select | QItemSelectionModel::Rows);
+
+  selecting = false;
+}
+
+void QtMoleculeListView::MoleculeUnselected(const moleculeId_t _id)
+{
+  if (selecting)
+    return;
+
+  selecting = true;
+
+  const QtMoleculeList *moleculelist = dynamic_cast<const QtMoleculeList *>(model());
+  QModelIndex index = moleculelist->MoleculeIdToIndex(_id);
+  ASSERT( selectionModel()->isSelected(index),
+      "QtMoleculeListView::MoleculeSelected() - row to molecule "
+      +toString(_id)+" is already unselected.");
+
+  // unselect the full row
+  expand(index);
+  selectionModel()->select(index, QItemSelectionModel::Deselect | QItemSelectionModel::Rows);
+
+  selecting = false;
+}
+
 
 void QtMoleculeListView::recieveNotification(Observable *publisher, Notification_ptr notification)
Index: src/UIElements/Views/Qt4/MoleculeList/QtMoleculeListView.hpp
===================================================================
--- src/UIElements/Views/Qt4/MoleculeList/QtMoleculeListView.hpp	(revision cc297688a2f09a635ccb45323617573684f51f9d)
+++ src/UIElements/Views/Qt4/MoleculeList/QtMoleculeListView.hpp	(revision 015f8c18d74c335a5af0741c3ff7f82dfcbfa0d1)
@@ -19,5 +19,8 @@
 #include "CodePatterns/Observer/Observer.hpp"
 
+#include "types.hpp"
+
 class QtMoleculeList;
+class QtSelectionChangedAgent;
 
 class QtMoleculeListView : public QTreeView, public Observer
@@ -31,6 +34,11 @@
   void setModel(QtMoleculeList *_moleculelist);
 
+  void setSelectionChangedAgent(QtSelectionChangedAgent *agent);
+
 public slots:
   void rowsSelected(const QItemSelection&, const QItemSelection&);
+
+  void MoleculeSelected(const moleculeId_t _id);
+  void MoleculeUnselected(const moleculeId_t _id);
 
 protected:
